HDU 5719 BestCoder 2nd Anniversary Arrange (DP)

41 篇文章 1 订阅
23 篇文章 0 订阅

Arrange

Time Limit: 8000/4000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)
Total Submission(s): 558    Accepted Submission(s): 198

Problem Description
Accidentally, Cupid, god of desire has hurt himself with his own dart and fallen in love with Psyche.

This has drawn the fury of his mother, Venus. The goddess then throws before Psyche a great mass of mixed crops.

There are n heaps of crops in total, numbered from 1 to n .

Psyche needs to arrange them in a certain order, assume crops on the i -th position is Ai .

She is given some information about the final order of the crops:

1. the minimum value of A1,A2,...,Ai is Bi .

2. the maximum value of A1,A2,...,Ai is Ci .

She wants to know the number of valid permutations. As this number can be large, output it modulo 998244353 .

Note that if there is no valid permutation, the answer is 0 .
 
Input
The first line of input contains an integer T (1T15) , which denotes the number of testcases.

For each test case, the first line of input contains single integer n (1n105) .

The second line contains n integers, the i -th integer denotes Bi (1Bin) .

The third line contains n integers, the i -th integer denotes Ci (1Cin) .

Output
For each testcase, print the number of valid permutations modulo 998244353 .
Sample Input
  
  
2 3 2 1 1 2 2 3 5 5 4 3 2 1 1 2 3 4 5
Sample Output
  
  
1 0
Hint
In the first example, there is only one valid permutation (2,1,3) . In the second example, it is obvious that there is no valid permutation.
Source
Recommend
wange2014   |   We have carefully selected several similar problems for you:  5722 5721 5720 5717 5716 

题目大意: 求出合法的1~n的全排列的种数。
         他会给你两行数。
         第一行表示的Ai 表示这个排列的前 i 个的最小值为Ai。
         第二行表示的B i表示这个排列的前 i 个的最大值为Bi。、
         要你求出符合这些条件的全排列的种数。

题解:首先排除掉5种不可能的情况,1.b[i]>b[i-1] 2,c[i]<c[i-1] 3,b[i]>c[i] 4.c[1]!=b[1] 5.b[i],c[i] < 1 || > n ,
           然后递推,如果当前产生的新的 b[i]或者 c[i] 那么dp[i] = dp[i-1] ,
           如果当前 b[i-1] = b[i] && c[i-1] = c[i] ,那么我们可以在 [b[i],c[i]]中任选一个数,
           但是由于这些数是互不相同的,所以每次我们的选的数都会逐渐变少。
           用num计算一下当前已经选了多少种,减掉之后答案即为 dp[i] = dp[i-1]*(c[i]-b[i]+1-num)。

AC代码:
#include<stdio.h>
#include<iostream>
#include<string.h>
#include<algorithm> 
using namespace std;
typedef long long LL;
const int mod =998244353;
const int N=100005;
int b[N];
int c[N];
LL dp[N];

int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
    	int n;
    	scanf("%d",&n);
    	int Min=999999;
    	int Max=-1;
    	int flag=1;
    	for(int i=1;i<=n;i++)
    	{
    		scanf("%d",&b[i]);
    		if(b[i]>Min) flag=0;
    		if(b[i]<1||b[i]>n) flag=0;
    		Min=min(Min,b[i]);
		}
		for(int i=1;i<=n;i++)
		{
			scanf("%d",&c[i]);
			if(c[i]<Max)flag=0;
			if(c[i]<1||c[i]>n) flag=0;
			if(c[i]<b[i]) flag=0;
			Max=max(Max,c[i]);
			
		}
		if(!flag||c[1]!=b[1]) puts("0"); //前 1个的最大最小值一定相等 ,都是这个数嘛 
		else
		{
			memset(dp,0,sizeof(dp));
			dp[1]=1;
			int num=1;
			for(int i=2;i<=n;i++) //dp核心 
			{
				if(c[i]==c[i-1]&&b[i]==b[i-1]&&b[i]!=c[i])
				{
					dp[i]=dp[i-1]*(c[i]-b[i]+1-num)%mod;
				}
				else if( b[i]<b[i-1]&&c[i-1]==c[i] || b[i]==b[i-1]&&c[i-1]<c[i] )
				{
						//dp[i] = dp[i-1]+1;
						dp[i]=dp[i-1];
				}
					num++; //已经选了多少种
			}
		  printf("%I64d\n",dp[n]);
		}
	}
    return 0;
}



  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值